summaryrefslogtreecommitdiff
path: root/prepare-release
diff options
context:
space:
mode:
Diffstat (limited to 'prepare-release')
-rwxr-xr-xprepare-release41
1 files changed, 29 insertions, 12 deletions
diff --git a/prepare-release b/prepare-release
index a9cc49cfd..dfa37631b 100755
--- a/prepare-release
+++ b/prepare-release
@@ -1,15 +1,18 @@
#!/bin/sh
-
set -e
+dpkg-checkbuilddeps -d 'libxml2-utils'
+
+if [ -n "${GBP_BUILD_DIR}" ]; then
+ cd "$GBP_BUILD_DIR"
+fi
+
VERSION=$(dpkg-parsechangelog | sed -n -e '/^Version:/s/^Version: //p')
DISTRIBUTION=$(dpkg-parsechangelog | sed -n -e '/^Distribution:/s/^Distribution: //p')
LIBAPTPKGVERSION="$(awk -v ORS='.' '/^\#define APT_PKG_M/ {print $3}' apt-pkg/init.h | sed 's/\.$//')"
LIBAPTINSTVERSION="$(egrep '^MAJOR=' apt-inst/makefile |cut -d '=' -f 2)"
-dpkg-checkbuilddeps -d 'libxml2-utils'
-
if [ "$1" = 'pre-export' ]; then
libraryversioncheck() {
local LIBRARY="$1"
@@ -47,27 +50,41 @@ if [ "$1" = 'pre-export' ]; then
sed -i -e "s/^<!ENTITY apt-product-version \".*\">$/<!ENTITY apt-product-version \"${VERSION}\">/" doc/apt-verbatim.ent
elif [ "$1" = 'post-build' ]; then
if [ "$DISTRIBUTION" != "UNRELEASED" ]; then
- echo >&2 "REMEMBER: Tag this release with »bzr tag ${VERSION}« if you are satisfied"
+ echo >&2 "REMEMBER: Tag this release with »git tag ${VERSION}« if you are satisfied"
else
echo >&2 'REMEMBER: Change to a valid distribution before release'
fi
- if ! xmllint --nonet --valid --noout $(find doc/ -maxdepth 1 -name '*.xml'); then
- echo >&2 'WARNING: original docbook manpages have errors!'
- elif ! xmllint --nonet --valid --noout $(find doc/ -mindepth 2 -maxdepth 2 -name '*.xml'); then
- echo >&2 'WARNING: translated docbook manpages have errors, but originals are okay!'
+
+ # check the manpages with each vendor for vendor-specific errors…
+ find vendor -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 2 | while read DISTRO; do
+ ln -sf ../vendor/${DISTRO}/apt-vendor.ent doc
+ if ! xmllint --nonet --valid --noout $(find doc/ -maxdepth 1 -name '*.xml'); then
+ echo >&2 "WARNING: original docbook manpages have errors with vendor ${DISTRO}!"
+ fi
+ done
+ # lets assume we will always have a german manpage translation
+ if [ -e 'doc/de/' ]; then
+ # … but check the translations only with one vendor for translation-specific errors
+ if ! xmllint --nonet --valid --noout $(find doc/ -mindepth 2 -maxdepth 2 -name '*.xml'); then
+ echo >&2 "WARNING: translated docbook manpages have errors!"
+ fi
+ else
+ echo >&2 "ERROR: translated manpages need to be build before they can be checked!"
fi
+ rm -f doc/apt-vendor.ent
+
elif [ "$1" = 'library' ]; then
librarysymbols() {
echo "Checking $1 in version $2"
local tmpfile=$(mktemp)
- dpkg-gensymbols -p${1}${2} -ebuild/bin/${1}.so.${2} -Idebian/${1}${2}.symbols -O/dev/null 2> /dev/null > $tmpfile
+ dpkg-gensymbols -p${1}${2} -ebuild/bin/${1}.so.${2} -Idebian/${1}${2}.symbols -O/dev/null 2> /dev/null > $tmpfile || true
echo '=== Missing symbols:'
- grep '^+#MISSING' $tmpfile
+ grep '^+#MISSING' $tmpfile || true
echo '=== New symbols:'
grep '^+ ' $tmpfile | cut -d' ' -f 2 | cut -d'@' -f 1 | c++filt | while read line; do
echo " (c++)\"${line}@Base\" $VERSION"
done | sort -u
- rm $tmpfile
+ rm -f $tmpfile
}
librarysymbols 'libapt-pkg' "${LIBAPTPKGVERSION}"
echo
@@ -77,7 +94,7 @@ else
\t$0 post-build
\t$0 library
-If you use »bzr builddeb« you can leave this script alone as it will
+If you use »git buildpackage« you can leave this script alone as it will
be run at the right places auto-magically. Otherwise you should use
»pre-export« to update po and pot files as well as version numbering.
»post-build« can be used to run some more or less useful checks later on.